// this file is part of the Quirk browser
// copyright 2021 by zamfofex
// license: GPLv3 or later

#ifndef QR_DISPLAY_H
#define QR_DISPLAY_H

#include "../util/config.h"
#include "../threads/threads.h"

typedef struct QrColor QrColor;
struct QrColor
{
	unsigned char red, green, blue;
};

typedef struct QrBackground QrBackground;
struct QrBackground
{
	QrColor color;
};

typedef struct QrRectangle *QrRectangle;
struct QrRectangle
{
	QrBackground background;
	QrNumber x, y;
	QrNumber width, height;
};

typedef struct QrText *QrText;
struct QrText
{
	char *string;
	QrNumber x, y;
};

typedef struct QrDisplaySize QrDisplaySize;
struct QrDisplaySize
{
	QrNumber width, height;
};

typedef enum QrDisplayEventType QrDisplayEventType;
enum QrDisplayEventType
{
	qr_close,
	qr_resize,
};

typedef struct QrDisplayEvent *QrDisplayEvent;
struct QrDisplayEvent
{
	QrDisplayEventType type;
};

typedef struct QrDisplay *QrDisplay;
struct QrDisplay
{
	void *data;
	void (*display)(QrDisplay display, QrRectangle *rect, QrText *text);
	QrNumber (*advance)(QrDisplay display, char *string);
	QrDisplaySize (*size)(QrDisplay display);
	void (*free)(QrDisplay display);
	
	QrQueue events;
};

QrDisplay qr_console(int in, int out);

#endif
