// this file is part of the Quirk browser
// copyright 2021 by zamfofex
// license: GPLv3 or later

import "./prelude.js"
import "./globals.js"
import jsdom from "jsdom"
import {commit} from "vm"
import csstom from "css-typed-om"
import {Box} from "./styles.js"
import {resume} from "./poll.js"
import {time} from "./timers.js"
import {url} from "builtin"

let {JSDOM} = jsdom

let beforeParse = () => commit()

self.exports =
{
	resume,
	get time() { return time },
}

let main = async () =>
{
	let {window} = await JSDOM.fromURL(url(), {runScripts: "dangerously", resources: "usable", beforeParse})
	self.getComputedStyle = window.getComputedStyle
	csstom.default(window)
	exports.root = () => Box(window, window.document.documentElement)
}

main()
