// this file is part of the Quirk browser
// copyright 2021 by zamfofex
// license: GPLv3 or later

import http from "stream-http"

let original = http.request
http.request = (...args) =>
{
	if (args.length >= 3)
	{
		let url = new URL(args.shift())
		Object.assign(args[0], {
			protocol: url.protocol,
			hostname: url.hostname,
			port: Number(url.port),
			path: url.pathname + url.search,
		})
	}
	let request = original(...args)
	let getHeader = request.getHeader
	request.getHeader = function (...args)
	{
		let header = getHeader.call(this, ...args)
		if (header !== null)
		return header
	}
	
	return request
}

export default http
