// this file is part of the Quirk browser
// copyright 2021 by zamfofex
// license: GPLv3 or later

import {new_context, run} from "builtin"

let context = Symbol("context")

let isContext = value => Boolean(value[context])

let runInContext = (script, value, options) =>
{
	if (!isContext(value))
		throw new TypeError("given object is not a context")
	
	return run(value[context], script)
}

let createContext = value =>
{
	value[context] = new_context(value)
	values.push(value)
}

export default {isContext, runInContext, createContext}

let values = []

let update = value =>
{
	let ctx = value[context]

	let prototype = Object.getPrototypeOf(value)
	let properties = Object.getOwnPropertyDescriptors(value)
	
	for (let name of Object.keys(properties))
		if (Object.hasOwnProperty(ctx, name))
			delete properties[name]
	
	Object.setPrototypeOf(ctx, prototype)
	Object.defineProperties(ctx, properties)
}

export let commit = () => {
	for (let value of values) update(value)
	values = []
}
