// this file is part of the Quirk browser
// copyright 2021 by zamfofex
// license: GPLv3 or later

let traverse = (w, value, replace = () => {}) =>
{
	let v = replace(value)
	if (v !== undefined) return v
	
	if (v instanceof w.CSSMathInvert)
		return w.CSS.div(w.CSS.number(1), traverse(w, v.value, replace))
	if (v instanceof w.CSSUnitValue)
		return v
	
	for (let cl of [w.CSSMathSum, w.CSSMathProduct, w.CSSMathMax, w.CSSMathMin])
	if (v instanceof cl)
		return new cl(...[...v.values].map(value => traverse(w, value, replace)))
	
	throw new Error("unrecognized type")
}

let Boxes = (w, node) =>
{
	if (node instanceof w.Element)
		return [
			{
				styles: node.computedStyleMap,
				children: [...node.childNodes].flatMap(node => Boxes(w, node)).filter(Boolean),
			}
		]
	// todo: this probably should be done in C
	if (node instanceof w.Text)
		return node.data.replace(/[\r\n\t ]+/g, " ").trim().split(" ")
}

export let Box = (w, node) => Boxes(w, node)?.[0]
