// this file is part of the Quirk browser
// copyright 2021 by zamfofex
// license: GPLv3 or later

import poll from "./poll.js"
import {now} from "builtin"

export let time = -1

let n = 1

let wait = async ms =>
{
	ms = Number(ms)
	if (ms < 0) ms = 0
	
	let t = now()
	
	while (true)
	{
		if (time === -1 || ms < time)
			time = ms
		await poll()
		ms -= now()
		if (ms <= 0) break
	}
	time = -1
}

let waitLoop = async (ms, f) =>
{
	while (true)
	{
		await wait(ms)
		f()
	}
}

export let setTimeout = (f, ms, ...args) =>
{
	if (typeof f !== "function") f = Function(f)
	wait(ms).then(() => f.call(...args))
	return n++
}

export let setInterval = (f, ms, ...args) =>
{
	if (typeof f !== "function") f = Function(f)
	waitLoop(ms, () => f.call(...args))
}

export let clearTimeout = () => { }
export let clearInterval = () => { }
