// this file is part of the Quirk browser
// copyright 2021 by zamfofex
// license: GPLv3 or later

#ifndef QR_LAYOUT_H
#define QR_LAYOUT_H

#include "../util/config.h"

typedef struct QrPadding QrPadding;
typedef struct QrBound QrBound;
typedef struct QrSizes QrSizes;
typedef enum QrAxis QrAxis;
typedef struct QrLayout *QrLayout;
typedef struct QrBox *QrBox;

struct QrPadding
{
	QrNumber start;
	QrNumber end;
};

struct QrBound
{
	QrNumber min;
	QrNumber max;
};

struct QrSizes
{
	QrBound formal_intrinsic;
	QrBound actual_intrinsic;
	QrBound normalized;
	QrNumber given;
	QrNumber formal;
	QrNumber actual;
};

enum QrAxis
{
	qr_vertical,
	qr_horizontal,
};

struct QrLayout
{
	void (*formal_intrinsic_sizes)(QrBox box, QrAxis axis);
	void (*formal_sizes)(QrBox box);
	void (*layout)(QrBox box);
};

struct QrBox
{
	QrBox *children;
	unsigned int count;
	
	QrAxis block_axis;
	QrAxis inline_axis;
	
	QrLayout layout;
	
	QrSizes sizes[2];
	QrNumber offsets[2];
	
	QrPadding margins[2];
	QrPadding paddings[2];
	QrNumber gaps[2];
	
	void *data;
	void (*normalized_sizes)(QrBox box, QrAxis axis);
	void (*normalized_sizes_again)(QrBox box, QrAxis axis, QrNumber percent, QrNumber padding_percent);
};

void qr_layout(QrBox box);

#endif
